// -*- C++ -*-
// $Id$

/**
 * Code generated by the The ACE ORB (TAO) IDL Compiler v2.2a_p14
 * TAO and the TAO IDL Compiler have been developed by:
 *       Center for Distributed Object Computing
 *       Washington University
 *       St. Louis, MO
 *       USA
 *       http://www.cs.wustl.edu/~schmidt/doc-center.html
 * and
 *       Distributed Object Computing Laboratory
 *       University of California at Irvine
 *       Irvine, CA
 *       USA
 * and
 *       Institute for Software Integrated Systems
 *       Vanderbilt University
 *       Nashville, TN
 *       USA
 *       http://www.isis.vanderbilt.edu/
 *
 * Information about TAO is available at:
 *     http://www.cs.wustl.edu/~schmidt/TAO.html
 **/

// TAO_IDL - Generated from
// be/be_codegen.cpp:461

#ifndef _TAO_IDL_INFOS_O4LSCJ_H_
#define _TAO_IDL_INFOS_O4LSCJ_H_

#include /**/ "ace/pre.h"

#include "InfoC.h"
#include "dds/DdsDcpsInfoUtilsS.h"
#include "dds/DdsDcpsPublicationS.h"
#include "dds/DdsDcpsSubscriptionS.h"
#include "dds/DCPS/InfoRepoDiscovery/DataWriterRemoteS.h"
#include "dds/DCPS/InfoRepoDiscovery/DataReaderRemoteS.h"
#include "tao/PortableServer/Basic_SArguments.h"
#include "tao/PortableServer/Special_Basic_SArguments.h"
#include "tao/PortableServer/Fixed_Size_SArgument_T.h"
#include "tao/PortableServer/Var_Size_SArgument_T.h"
#include "tao/PortableServer/Object_SArg_Traits.h"
#include "tao/PortableServer/Special_Basic_SArguments.h"
#include "tao/PortableServer/UB_String_SArguments.h"
#include "tao/PortableServer/Object_SArg_Traits.h"
#include "tao/PortableServer/get_arg.h"
#include "tao/Special_Basic_Arguments.h"
#include "tao/UB_String_Arguments.h"

#if !defined (ACE_LACKS_PRAGMA_ONCE)
# pragma once
#endif /* ACE_LACKS_PRAGMA_ONCE */

#include "tao/PortableServer/PortableServer.h"
#include "tao/PortableServer/Servant_Base.h"

OPENDDS_BEGIN_VERSIONED_NAMESPACE_DECL



// TAO_IDL - Generated from
// be/be_visitor_arg_traits.cpp:68


OPENDDS_END_VERSIONED_NAMESPACE_DECL


TAO_BEGIN_VERSIONED_NAMESPACE_DECL


// Arg traits specializations.
namespace TAO
{

  // TAO_IDL - Generated from
  // be/be_visitor_arg_traits.cpp:147

#if !defined (_OPENDDS_DCPS_DCPSINFO__SARG_TRAITS_)
#define _OPENDDS_DCPS_DCPSINFO__SARG_TRAITS_

  template<>
  class  SArg_Traits< ::OpenDDS::DCPS::DCPSInfo>
    : public
        Object_SArg_Traits_T<
            ::OpenDDS::DCPS::DCPSInfo_ptr,
            ::OpenDDS::DCPS::DCPSInfo_var,
            ::OpenDDS::DCPS::DCPSInfo_out,
            TAO::Any_Insert_Policy_Noop
          >
  {
  };

#endif /* end #if !defined */
}

TAO_END_VERSIONED_NAMESPACE_DECL


OPENDDS_BEGIN_VERSIONED_NAMESPACE_DECL




// TAO_IDL - Generated from
// be/be_visitor_module/module_sh.cpp:38

namespace POA_OpenDDS
{
  

  // TAO_IDL - Generated from
  // be/be_visitor_module/module_sh.cpp:38

  namespace DCPS
  {
    

    // TAO_IDL - Generated from
    // be/be_visitor_interface/interface_sh.cpp:76

    class DCPSInfo;
    typedef DCPSInfo *DCPSInfo_ptr;

    class OpenDDS_InfoRepoDiscovery_Export DCPSInfo
      : public virtual PortableServer::ServantBase
    {
    protected:
      DCPSInfo (void);
    
    public:
      /// Useful for template programming.
      typedef ::OpenDDS::DCPS::DCPSInfo _stub_type;
      typedef ::OpenDDS::DCPS::DCPSInfo_ptr _stub_ptr_type;
      typedef ::OpenDDS::DCPS::DCPSInfo_var _stub_var_type;

      DCPSInfo (const DCPSInfo& rhs);
      virtual ~DCPSInfo (void);

      virtual ::CORBA::Boolean _is_a (const char* logical_type_id);

      virtual void _dispatch (
          TAO_ServerRequest & req,
          TAO::Portable_Server::Servant_Upcall *servant_upcall);
      
      ::OpenDDS::DCPS::DCPSInfo *_this (void);
      
      virtual const char* _interface_repository_id (void) const;

      // TAO_IDL - Generated from
      // be/be_visitor_operation/operation_sh.cpp:39

      virtual ::CORBA::Boolean attach_participant (
        ::DDS::DomainId_t domainId,
        const ::OpenDDS::DCPS::RepoId & participantId) = 0;

      static void attach_participant_skel (
          TAO_ServerRequest &server_request,
          TAO::Portable_Server::Servant_Upcall *servant_upcall,
          TAO_ServantBase *servant);

      // TAO_IDL - Generated from
      // be/be_visitor_operation/operation_sh.cpp:39

      virtual ::OpenDDS::DCPS::TopicStatus assert_topic (
        ::OpenDDS::DCPS::RepoId_out topicId,
        ::DDS::DomainId_t domainId,
        const ::OpenDDS::DCPS::RepoId & participantId,
        const char * topicName,
        const char * DataTypeName,
        const ::DDS::TopicQos & qos,
        ::CORBA::Boolean hasDcpsKey) = 0;

      static void assert_topic_skel (
          TAO_ServerRequest &server_request,
          TAO::Portable_Server::Servant_Upcall *servant_upcall,
          TAO_ServantBase *servant);

      // TAO_IDL - Generated from
      // be/be_visitor_operation/operation_sh.cpp:39

      virtual ::OpenDDS::DCPS::TopicStatus find_topic (
        ::DDS::DomainId_t domainId,
        const char * topicName,
        ::CORBA::String_out DataTypeName,
        ::DDS::TopicQos_out qos,
        ::OpenDDS::DCPS::RepoId_out topicId) = 0;

      static void find_topic_skel (
          TAO_ServerRequest &server_request,
          TAO::Portable_Server::Servant_Upcall *servant_upcall,
          TAO_ServantBase *servant);

      // TAO_IDL - Generated from
      // be/be_visitor_operation/operation_sh.cpp:39

      virtual ::OpenDDS::DCPS::TopicStatus remove_topic (
        ::DDS::DomainId_t domainId,
        const ::OpenDDS::DCPS::RepoId & participantId,
        const ::OpenDDS::DCPS::RepoId & topicId) = 0;

      static void remove_topic_skel (
          TAO_ServerRequest &server_request,
          TAO::Portable_Server::Servant_Upcall *servant_upcall,
          TAO_ServantBase *servant);

      // TAO_IDL - Generated from
      // be/be_visitor_operation/operation_sh.cpp:39

      virtual ::OpenDDS::DCPS::RepoId add_publication (
        ::DDS::DomainId_t domainId,
        const ::OpenDDS::DCPS::RepoId & participantId,
        const ::OpenDDS::DCPS::RepoId & topicId,
        ::OpenDDS::DCPS::DataWriterRemote_ptr publication,
        const ::DDS::DataWriterQos & qos,
        const ::OpenDDS::DCPS::TransportLocatorSeq & transInfo,
        const ::DDS::PublisherQos & publisherQos) = 0;

      static void add_publication_skel (
          TAO_ServerRequest &server_request,
          TAO::Portable_Server::Servant_Upcall *servant_upcall,
          TAO_ServantBase *servant);

      // TAO_IDL - Generated from
      // be/be_visitor_operation/operation_sh.cpp:39

      virtual void remove_publication (
        ::DDS::DomainId_t domainId,
        const ::OpenDDS::DCPS::RepoId & participantId,
        const ::OpenDDS::DCPS::RepoId & publicationId) = 0;

      static void remove_publication_skel (
          TAO_ServerRequest &server_request,
          TAO::Portable_Server::Servant_Upcall *servant_upcall,
          TAO_ServantBase *servant);

      // TAO_IDL - Generated from
      // be/be_visitor_operation/operation_sh.cpp:39

      virtual ::OpenDDS::DCPS::RepoId add_subscription (
        ::DDS::DomainId_t domainId,
        const ::OpenDDS::DCPS::RepoId & participantId,
        const ::OpenDDS::DCPS::RepoId & topicId,
        ::OpenDDS::DCPS::DataReaderRemote_ptr subscription,
        const ::DDS::DataReaderQos & qos,
        const ::OpenDDS::DCPS::TransportLocatorSeq & transInfo,
        const ::DDS::SubscriberQos & subscriberQos,
        const char * filterClassName,
        const char * filterExpression,
        const ::DDS::StringSeq & exprParams) = 0;

      static void add_subscription_skel (
          TAO_ServerRequest &server_request,
          TAO::Portable_Server::Servant_Upcall *servant_upcall,
          TAO_ServantBase *servant);

      // TAO_IDL - Generated from
      // be/be_visitor_operation/operation_sh.cpp:39

      virtual void remove_subscription (
        ::DDS::DomainId_t domainId,
        const ::OpenDDS::DCPS::RepoId & participantId,
        const ::OpenDDS::DCPS::RepoId & subscriptionId) = 0;

      static void remove_subscription_skel (
          TAO_ServerRequest &server_request,
          TAO::Portable_Server::Servant_Upcall *servant_upcall,
          TAO_ServantBase *servant);

      // TAO_IDL - Generated from
      // be/be_visitor_operation/operation_sh.cpp:39

      virtual ::OpenDDS::DCPS::AddDomainStatus add_domain_participant (
        ::DDS::DomainId_t domain,
        const ::DDS::DomainParticipantQos & qos) = 0;

      static void add_domain_participant_skel (
          TAO_ServerRequest &server_request,
          TAO::Portable_Server::Servant_Upcall *servant_upcall,
          TAO_ServantBase *servant);

      // TAO_IDL - Generated from
      // be/be_visitor_operation/operation_sh.cpp:39

      virtual void remove_domain_participant (
        ::DDS::DomainId_t domainId,
        const ::OpenDDS::DCPS::RepoId & participantId) = 0;

      static void remove_domain_participant_skel (
          TAO_ServerRequest &server_request,
          TAO::Portable_Server::Servant_Upcall *servant_upcall,
          TAO_ServantBase *servant);

      // TAO_IDL - Generated from
      // be/be_visitor_operation/operation_sh.cpp:39

      virtual void association_complete (
        ::DDS::DomainId_t domainId,
        const ::OpenDDS::DCPS::RepoId & participantId,
        const ::OpenDDS::DCPS::RepoId & localId,
        const ::OpenDDS::DCPS::RepoId & remoteId) = 0;

      static void association_complete_skel (
          TAO_ServerRequest &server_request,
          TAO::Portable_Server::Servant_Upcall *servant_upcall,
          TAO_ServantBase *servant);

      // TAO_IDL - Generated from
      // be/be_visitor_operation/operation_sh.cpp:39

      virtual void disassociate_participant (
        ::DDS::DomainId_t domainId,
        const ::OpenDDS::DCPS::RepoId & local_id,
        const ::OpenDDS::DCPS::RepoId & remote_id) = 0;

      static void disassociate_participant_skel (
          TAO_ServerRequest &server_request,
          TAO::Portable_Server::Servant_Upcall *servant_upcall,
          TAO_ServantBase *servant);

      // TAO_IDL - Generated from
      // be/be_visitor_operation/operation_sh.cpp:39

      virtual void disassociate_subscription (
        ::DDS::DomainId_t domainId,
        const ::OpenDDS::DCPS::RepoId & participantId,
        const ::OpenDDS::DCPS::RepoId & local_id,
        const ::OpenDDS::DCPS::RepoId & remote_id) = 0;

      static void disassociate_subscription_skel (
          TAO_ServerRequest &server_request,
          TAO::Portable_Server::Servant_Upcall *servant_upcall,
          TAO_ServantBase *servant);

      // TAO_IDL - Generated from
      // be/be_visitor_operation/operation_sh.cpp:39

      virtual void disassociate_publication (
        ::DDS::DomainId_t domainId,
        const ::OpenDDS::DCPS::RepoId & participantId,
        const ::OpenDDS::DCPS::RepoId & local_id,
        const ::OpenDDS::DCPS::RepoId & remote_id) = 0;

      static void disassociate_publication_skel (
          TAO_ServerRequest &server_request,
          TAO::Portable_Server::Servant_Upcall *servant_upcall,
          TAO_ServantBase *servant);

      // TAO_IDL - Generated from
      // be/be_visitor_operation/operation_sh.cpp:39

      virtual void ignore_domain_participant (
        ::DDS::DomainId_t domainId,
        const ::OpenDDS::DCPS::RepoId & myParticipantId,
        const ::OpenDDS::DCPS::RepoId & ignoreId) = 0;

      static void ignore_domain_participant_skel (
          TAO_ServerRequest &server_request,
          TAO::Portable_Server::Servant_Upcall *servant_upcall,
          TAO_ServantBase *servant);

      // TAO_IDL - Generated from
      // be/be_visitor_operation/operation_sh.cpp:39

      virtual void ignore_topic (
        ::DDS::DomainId_t domainId,
        const ::OpenDDS::DCPS::RepoId & myParticipantId,
        const ::OpenDDS::DCPS::RepoId & ignoreId) = 0;

      static void ignore_topic_skel (
          TAO_ServerRequest &server_request,
          TAO::Portable_Server::Servant_Upcall *servant_upcall,
          TAO_ServantBase *servant);

      // TAO_IDL - Generated from
      // be/be_visitor_operation/operation_sh.cpp:39

      virtual void ignore_subscription (
        ::DDS::DomainId_t domainId,
        const ::OpenDDS::DCPS::RepoId & myParticipantId,
        const ::OpenDDS::DCPS::RepoId & ignoreId) = 0;

      static void ignore_subscription_skel (
          TAO_ServerRequest &server_request,
          TAO::Portable_Server::Servant_Upcall *servant_upcall,
          TAO_ServantBase *servant);

      // TAO_IDL - Generated from
      // be/be_visitor_operation/operation_sh.cpp:39

      virtual void ignore_publication (
        ::DDS::DomainId_t domainId,
        const ::OpenDDS::DCPS::RepoId & myParticipantId,
        const ::OpenDDS::DCPS::RepoId & ignoreId) = 0;

      static void ignore_publication_skel (
          TAO_ServerRequest &server_request,
          TAO::Portable_Server::Servant_Upcall *servant_upcall,
          TAO_ServantBase *servant);

      // TAO_IDL - Generated from
      // be/be_visitor_operation/operation_sh.cpp:39

      virtual ::CORBA::Boolean update_domain_participant_qos (
        ::DDS::DomainId_t domain,
        const ::OpenDDS::DCPS::RepoId & participantId,
        const ::DDS::DomainParticipantQos & qos) = 0;

      static void update_domain_participant_qos_skel (
          TAO_ServerRequest &server_request,
          TAO::Portable_Server::Servant_Upcall *servant_upcall,
          TAO_ServantBase *servant);

      // TAO_IDL - Generated from
      // be/be_visitor_operation/operation_sh.cpp:39

      virtual ::CORBA::Boolean update_topic_qos (
        const ::OpenDDS::DCPS::RepoId & topicId,
        ::DDS::DomainId_t domainId,
        const ::OpenDDS::DCPS::RepoId & participantId,
        const ::DDS::TopicQos & qos) = 0;

      static void update_topic_qos_skel (
          TAO_ServerRequest &server_request,
          TAO::Portable_Server::Servant_Upcall *servant_upcall,
          TAO_ServantBase *servant);

      // TAO_IDL - Generated from
      // be/be_visitor_operation/operation_sh.cpp:39

      virtual ::CORBA::Boolean update_publication_qos (
        ::DDS::DomainId_t domainId,
        const ::OpenDDS::DCPS::RepoId & participantId,
        const ::OpenDDS::DCPS::RepoId & publicationId,
        const ::DDS::DataWriterQos & qos,
        const ::DDS::PublisherQos & publisherQos) = 0;

      static void update_publication_qos_skel (
          TAO_ServerRequest &server_request,
          TAO::Portable_Server::Servant_Upcall *servant_upcall,
          TAO_ServantBase *servant);

      // TAO_IDL - Generated from
      // be/be_visitor_operation/operation_sh.cpp:39

      virtual ::CORBA::Boolean update_subscription_qos (
        ::DDS::DomainId_t domainId,
        const ::OpenDDS::DCPS::RepoId & participantId,
        const ::OpenDDS::DCPS::RepoId & subscriptionId,
        const ::DDS::DataReaderQos & qos,
        const ::DDS::SubscriberQos & subscriberQos) = 0;

      static void update_subscription_qos_skel (
          TAO_ServerRequest &server_request,
          TAO::Portable_Server::Servant_Upcall *servant_upcall,
          TAO_ServantBase *servant);

      // TAO_IDL - Generated from
      // be/be_visitor_operation/operation_sh.cpp:39

      virtual ::CORBA::Boolean update_subscription_params (
        ::DDS::DomainId_t domainId,
        const ::OpenDDS::DCPS::RepoId & participantId,
        const ::OpenDDS::DCPS::RepoId & subscriptionId,
        const ::DDS::StringSeq & exprParams) = 0;

      static void update_subscription_params_skel (
          TAO_ServerRequest &server_request,
          TAO::Portable_Server::Servant_Upcall *servant_upcall,
          TAO_ServantBase *servant);

      // TAO_IDL - Generated from
      // be/be_visitor_operation/operation_sh.cpp:39

      virtual void shutdown (
        void) = 0;

      static void shutdown_skel (
          TAO_ServerRequest &server_request,
          TAO::Portable_Server::Servant_Upcall *servant_upcall,
          TAO_ServantBase *servant);

      // TAO_IDL - Generated from
      // be/be_visitor_operation/operation_sh.cpp:39

      virtual char * dump_to_string (
        void) = 0;

      static void dump_to_string_skel (
          TAO_ServerRequest &server_request,
          TAO::Portable_Server::Servant_Upcall *servant_upcall,
          TAO_ServantBase *servant);
    };
  
  // TAO_IDL - Generated from
  // be/be_visitor_module/module_sh.cpp:69

  } // module OpenDDS::DCPS

// TAO_IDL - Generated from
// be/be_visitor_module/module_sh.cpp:69

} // module OpenDDS

OPENDDS_END_VERSIONED_NAMESPACE_DECL



#include /**/ "ace/post.h"

#endif /* ifndef */

